package org.dromara.work.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.TpWechatUser;
import org.dromara.work.domain.bo.TpWechatUserBo;
import org.dromara.work.domain.vo.TpWechatUserVo;
import org.dromara.work.mapper.TpWechatUserMapper;
import org.dromara.work.service.ITpWechatUserService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 微信使用人修改历史Service业务层处理
 *
 * @author Maosw
 * @date 2024-08-12
 */
@RequiredArgsConstructor
@Service
public class TpWechatUserServiceImpl implements ITpWechatUserService {

    private final TpWechatUserMapper baseMapper;

    /**
     * 查询微信使用人修改历史
     *
     * @param id 主键
     * @return 微信使用人修改历史
     */
    @Override
    public TpWechatUserVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询微信使用人修改历史列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 微信使用人修改历史分页列表
     */
    @Override
    public TableDataInfo<TpWechatUserVo> queryPageList(TpWechatUserBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpWechatUser> lqw = buildQueryWrapper(bo);
        Page<TpWechatUserVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的微信使用人修改历史列表
     *
     * @param bo 查询条件
     * @return 微信使用人修改历史列表
     */
    @Override
    public List<TpWechatUserVo> queryList(TpWechatUserBo bo) {
        LambdaQueryWrapper<TpWechatUser> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpWechatUser> buildQueryWrapper(TpWechatUserBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpWechatUser> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getWid() != null, TpWechatUser::getWid, bo.getWid());
        lqw.eq(bo.getUid() != null, TpWechatUser::getUid, bo.getUid());
        lqw.eq(StringUtils.isNotBlank(bo.getUser()), TpWechatUser::getUser, bo.getUser());
        lqw.eq(bo.getNowTime() != null, TpWechatUser::getNowTime, bo.getNowTime());
        lqw.eq(bo.getNowPrice() != null, TpWechatUser::getNowPrice, bo.getNowPrice());
        lqw.eq(bo.getEndTime() != null, TpWechatUser::getEndTime, bo.getEndTime());
        lqw.eq(bo.getAddUser() != null, TpWechatUser::getAddUser, bo.getAddUser());
        lqw.like(StringUtils.isNotBlank(bo.getAddname()), TpWechatUser::getAddname, bo.getAddname());
        lqw.eq(bo.getAddTime() != null, TpWechatUser::getAddTime, bo.getAddTime());
        return lqw;
    }

    /**
     * 新增微信使用人修改历史
     *
     * @param bo 微信使用人修改历史
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpWechatUserBo bo) {
        TpWechatUser add = MapstructUtils.convert(bo, TpWechatUser.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改微信使用人修改历史
     *
     * @param bo 微信使用人修改历史
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpWechatUserBo bo) {
        TpWechatUser update = MapstructUtils.convert(bo, TpWechatUser.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpWechatUser entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除微信使用人修改历史信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
